'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = _interopDefault(require('styled-components'));

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var _templateObject = taggedTemplateLiteral(['\n    padding: ', ';\n    ', '\n    ', ' \n    ', '\n    ', '\n  '], ['\n    padding: ', ';\n    ', '\n    ', ' \n    ', '\n    ', '\n  ']),
    _templateObject2 = taggedTemplateLiteral(['\n      display: flex;\n      align-content: flex-start;\n      flex-driection: ', ';\n      flex-wrap: ', ';\n      ', '\n      ', '\n      ', '\n\n      > * {\n        max-width: 100%;\n      }\n    '], ['\n      display: flex;\n      align-content: flex-start;\n      flex-driection: ', ';\n      flex-wrap: ', ';\n      ', '\n      ', '\n      ', '\n\n      > * {\n        max-width: 100%;\n      }\n    ']);

var defaultBreakpoints = {
  tn: '0px', xs: '500px', sm: '768px', md: '992px',
  lg: '1200px', xl: '1440px', hg: '1920px'
};

var mediaBasis = function mediaBasis(basis) {
  if (typeof basis === 'string') {
    return 'flex-basis: ' + basis + ';';
  } else if (basis === Object(basis)) {
    return Object.keys(basis).reduce(function (basisString, key) {
      return '\n      ' + basisString + '\n      @media (min-width: ' + (defaultBreakpoints[key] ? defaultBreakpoints[key] : key) + ') {\n        flex-basis: ' + basis[key] + ';\n      }\n    ';
    }, '');
  }
  return 'flex-basis: auto;';
};

var FlexChild = function FlexChild(_ref) {
  var className = _ref.className,
      children = _ref.children,
      _grow = _ref._grow,
      _basis = _ref._basis,
      _reset = _ref._reset,
      _scroll = _ref._scroll,
      cssSpacing = _ref.cssSpacing,
      isInline = _ref.isInline;

  var StyledFlexChild = styled.div(_templateObject, cssSpacing, _grow ? 'flex-grow: 1;' : '', _basis ? mediaBasis(_basis) : '', _scroll ? '\n      > * {\n        max-width: calc(100% - (' + cssSpacing + ' * 2));\n        max-height: calc(100% - (' + cssSpacing + ' * 2));\n        overflow: auto;\n      }\n    ' : '', !isInline && _grow && _reset ? '\n      position: relative;\n      > * {\n        position: absolute;\n        width: calc(100% - (' + cssSpacing + ' * 2));\n        height: calc(100% - (' + cssSpacing + ' * 2));\n      }\n    ' : '');

  var renderChildWithClassName = function renderChildWithClassName() {
    return className ? React.createElement(
      'div',
      { className: className },
      children
    ) : children;
  };

  return _reset || _scroll ? React.createElement(
    StyledFlexChild,
    null,
    React.createElement(
      'div',
      null,
      renderChildWithClassName()
    )
  ) : React.createElement(
    StyledFlexChild,
    null,
    renderChildWithClassName()
  );
};

FlexChild.propTypes = {
  className: PropTypes.string,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
  _grow: PropTypes.bool,
  _basis: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
  _reset: PropTypes.bool,
  _scroll: PropTypes.bool,
  isInline: PropTypes.bool,
  cssSpacing: PropTypes.string
};

FlexChild.defaultProps = {
  className: null,
  _grow: false,
  _reset: false,
  _scroll: false,
  _basis: null,
  isInline: false,
  cssSpacing: '0px'
};

var Flex = function (_React$PureComponent) {
  inherits(Flex, _React$PureComponent);

  function Flex() {
    classCallCheck(this, Flex);
    return possibleConstructorReturn(this, (Flex.__proto__ || Object.getPrototypeOf(Flex)).apply(this, arguments));
  }

  createClass(Flex, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var cssSpacing = '' + this.props.gutter / 2 + this.props.gutterUnits;

      var StyledFlex = styled.div(_templateObject2, this.props.inline ? 'row' : 'column', this.props.wrap && this.props.inline ? 'wrap' : 'no-wrap', this.props.itemsCenter ? 'align-items: center;' : '', this.props.fullHeight ? 'min-height: 100%;' : '', this.props.container ? '\n        margin: 0;\n        padding: ' + cssSpacing + ';\n      ' : '\n        margin: -' + cssSpacing + ';\n      ');

      var flexChildren = React.Children.map(this.props.children, function (child) {
        // Wrap any children in a div to prevent potential css flex layout overrides.
        if (child) {
          var flexChildProps = Object.keys(FlexChild.defaultProps).reduce(function (props, key) {
            if (key !== 'className') {
              props[key] = child.props[key];
            }
            return props;
          }, {});

          var childPropsWithoutFlexProps = Object.assign({}, child.props);

          Object.keys(flexChildProps).forEach(function (key) {
            delete childPropsWithoutFlexProps[key];
          });

          var wrapped = React.createElement('div', flexChildProps, Object.assign({}, child, {
            props: childPropsWithoutFlexProps
          }));

          return React.createElement(FlexChild, _extends({}, wrapped.props, { cssSpacing: cssSpacing, isInline: _this2.props.inline }));
        }
        return null;
      });

      return this.props.className ? React.createElement(
        'div',
        { className: this.props.className },
        React.createElement(
          StyledFlex,
          null,
          flexChildren
        )
      ) : React.createElement(
        StyledFlex,
        null,
        flexChildren
      );
    }
  }]);
  return Flex;
}(React.PureComponent);

Flex.propTypes = {
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
  className: PropTypes.string,
  inline: PropTypes.bool,
  wrap: PropTypes.bool,
  itemsCenter: PropTypes.bool,
  fullHeight: PropTypes.bool,
  container: PropTypes.bool,
  gutter: PropTypes.number,
  gutterUnits: PropTypes.string
};

Flex.defaultProps = {
  className: null,
  inline: false,
  wrap: false,
  itemsCenter: false,
  fullHeight: false,
  container: false,
  gutter: 0,
  gutterUnits: 'px'
};

exports.Flex = Flex;
